# Headless CMS and website for Energo Savings
This project is a monorepository that consists of a headless CMS Payload CMS and frontend framework Next.js.

It was also built as a demonstration of headless CMS usage for a diploma thesis.

If you want to learn more about Energo Savings, you can check out the company website https://energosavings.cz.

## How to run locally
- To run this application a Node.js runtime is needed
- Download and run the installer from https://nodejs.org/en/download/
- Node.js will install an NPM as a package manager automatically
- Install Yarn with NPM using `npm install yarn -g`
- Clone the repo to your local machine using `git clone https://github.com/choutkamartin/energosavings.git`
- Proceed to the folder where you cloned the repository
- At the root of the project run `yarn install`
- This will install all the dependencies needed
- At the root of each app in the monorepo is `.env.example` file
- All of these environment variables should be filled in to achieve a 100% working application
- To achieve a fully working application, you should install a local MongoDB instance or use MongoDB Atlas
- Run `yarn build` or any other script specified in `package.json`


## Images
### Headless CMS (Payload CMS)
![Welcome page](https://github.com/choutkamartin/energosavings/assets/45522695/d192727a-cdd9-4763-9611-41f9f7fcb2b1)
![Edit page](https://github.com/choutkamartin/energosavings/assets/45522695/b949654b-ada9-4dca-a22d-383d5f1e877a)

### Website (Next.js)
![Landing page](https://github.com/choutkamartin/energosavings/assets/45522695/16e85ee9-1d22-488b-acb5-d0b7c81994df)
