import { WIDTH } from "./style";
import { Page } from "payload-types";

import { joinClassNames } from "utils/helper";

import { RenderBlocks } from "components/RenderBlocks";

type ColumnBlock = Extract<
  Extract<
    Extract<Page["layout"][number], { blockType: "container" }>["layout"][number],
    { blockType: "columns" }
  >["layout"][number],
  { blockType: "column" }
>;

const Column = ({ width, layout }: ColumnBlock) => {
  return (
    <div className={joinClassNames(WIDTH[width])}>
      <RenderBlocks blocks={layout} />
    </div>
  );
};

export default Column;
