import { Page } from "payload-types";

import { MARGIN_BOTTOM } from "styles/constants";

import { joinClassNames } from "utils/helper";

import { RenderBlocks } from "components/RenderBlocks";

type ColumnsBlock = Extract<
  Extract<Page["layout"][number], { blockType: "container" }>["layout"][number],
  { blockType: "columns" }
>;

const Columns = ({ layout, marginBottom }: ColumnsBlock) => {
  return (
    <div
      className={joinClassNames(
        "flex flex-col md:flex-row gap-16 lg:gap-32 md:items-center",
        marginBottom && MARGIN_BOTTOM[marginBottom]
      )}
    >
      <RenderBlocks blocks={layout} />
    </div>
  );
};

export default Columns;
