import { Page } from "payload-types";

import { MARGIN_BOTTOM } from "styles/constants";

import { joinClassNames } from "utils/helper";

type FeaturesBlock = Extract<
  Extract<Page["layout"][number], { blockType: "container" }>["layout"][number],
  { blockType: "features" }
>;

const Features = ({ items, marginBottom }: FeaturesBlock) => {
  return (
    <div
      className={joinClassNames(
        "grid grid-cols-2 lg:grid-cols-4 justify-between items-center bg-primary-600 p-8 gap-x-8 gap-y-16 rounded-lg text-white shadow",
        marginBottom && MARGIN_BOTTOM[marginBottom]
      )}
    >
      {items.map((item, index) => (
        <div className="text-center" key={index}>
          <p className="text-4xl font-display tracking-wider">{item.title}</p>
          <p className="text-sm">{item.description}</p>
        </div>
      ))}
    </div>
  );
};

export default Features;
