import { ReactNode } from "react";

import { joinClassNames } from "utils/helper";

type ListProps = {
  children: ReactNode | ReactNode[];
  className: string;
};

const List = ({ children, className }: ListProps) => (
  <ul className={joinClassNames("list-disc list-inside text-gray-600", className)}>{children}</ul>
);

type ItemProps = {
  children: ReactNode | ReactNode[];
};

const Item = ({ children }: ItemProps) => <li>{children}</li>;

List.Item = Item;
export default List;
