import { ChevronDoubleLeftIcon, ChevronDoubleRightIcon } from "@heroicons/react/24/solid";

import { joinClassNames } from "utils/helper";

type Props = {
  totalPages: number;
  handlePageChange: any;
  page: number;
  total: number;
};

export default function Pagination({ totalPages, handlePageChange, page }: Props) {
  return (
    <nav className="flex space-x-4">
      {page > 1 && (
        <button
          onClick={() => handlePageChange(page - 1)}
          className="border border-gray-400 w-10 h-10 text-center inline-flex items-center justify-center font-display text-gray-400 hover:text-black hover:border-black rounded-sm transition-colors"
        >
          <ChevronDoubleLeftIcon className="w-5 h-5" />
        </button>
      )}
      {Array(totalPages)
        .fill(0)
        .map((item, index) => {
          const active = page === index + 1 ? true : false;
          return (
            <button
              onClick={() => handlePageChange(index + 1)}
              key={index}
              className={joinClassNames(
                "border text-lg w-10 h-10 text-center inline-flex items-center justify-center font-display  hover:text-black hover:border-black rounded-sm transition-colors",
                active ? "text-primary-500 border-primary-500" : "text-gray-400 border-gray-400"
              )}
            >
              {index + 1}
            </button>
          );
        })}
      {page < totalPages && (
        <button
          onClick={() => handlePageChange(page + 1)}
          className="border border-gray-400 w-10 h-10 text-center inline-flex items-center justify-center font-display text-gray-400 hover:text-black hover:border-black rounded-sm transition-colors"
        >
          <ChevronDoubleRightIcon className="w-5 h-5" />
        </button>
      )}
    </nav>
  );
}
