import { NextSeo } from "next-seo";

import { Button } from "components/Button";

const Error = () => (
  <>
    <NextSeo title="404" description="Stránka nebyla nalezena" />
    <div className="h-screen max-w-5xl mx-auto flex flex-col items-center justify-center">
      <p className="text-8xl font-display text-primary-600">500</p>
      <p className="text-lg text-gray-600 mb-6">
        Na této stránce se něco pokazilo. Chyba není na Vaší straně.
      </p>
      <Button
        size="md"
        style="primary"
        variant="primary"
        text="Zpět na domovskou stránku"
        link={{ url: "/" }}
      />
    </div>
  </>
);

export default Error;
