import type { NextApiRequest, NextApiResponse } from "next";

export default async function handler(req: NextApiRequest, res: NextApiResponse) {
  const paths = req.body;
  try {
    for (let index = 0; index < paths.length; index++) {
      const path = paths[index];
      await res.revalidate(path);
    }
    return res.json({ revalidated: true });
  } catch (err) {
    return res.status(500).send("Error revalidating");
  }
}
