import { NextSeo } from "next-seo";
import { Page } from "payload-types";
import { Fragment, useEffect, useState } from "react";

import { RenderBlocks } from "components/RenderBlocks";

const Index = () => {
  const [page, setPage] = useState<Page | null>(null);

  useEffect(() => {
    const listener = (event: MessageEvent) => {
      if (event.data.cmsLivePreviewData) {
        setPage(event.data.cmsLivePreviewData);
      }
    };
    window.addEventListener("message", listener, false);
    return () => {
      window.removeEventListener("message", listener);
    };
  }, []);

  return (
    <Fragment>
      <NextSeo title={page?.meta.title} description={page?.meta.description} />
      {/* {preview && <PreviewBar />} */}
      <RenderBlocks blocks={page?.layout} />
    </Fragment>
  );
};

export default Index;
