import qs from "qs";

import { fetcher } from "utils/helper";

export const fetchEmployee = async (slug: string, preview: boolean = false) => {
  const query = {
    slug: {
      equals: slug,
    },
  };

  const stringifiedQuery = qs.stringify(
    {
      where: query,
      draft: preview,
    },
    { addQueryPrefix: true }
  );

  const url = `/api/employees${stringifiedQuery}`;
  const data = await fetcher(url);
  if (!data) return;

  const page = data.docs[0];

  return page;
};

export const fetchEmployeeSlugs = async () => {
  const url = `/api/employees/slugs`;
  const data = await fetcher(url);

  return data;
};
