import qs from "qs";

import { fetcher } from "utils/helper";

export const fetchPost = async (slug: string, preview: boolean = false) => {
  const query = {
    slug: {
      equals: slug,
    },
  };

  const stringifiedQuery = qs.stringify(
    {
      where: query,
      draft: preview,
    },
    { addQueryPrefix: true }
  );

  const url = `/api/posts${stringifiedQuery}`;

  const data = await fetcher(url);
  if (!data) return;

  const page = data.docs[0];

  return page;
};

export const fetchPosts = async (ids: string[], preview: boolean = false) => {
  const query = {
    category: {
      contains: ids,
    },
  };

  const stringifiedQuery = qs.stringify(
    {
      where: query,
      draft: preview,
    },
    { addQueryPrefix: true }
  );

  const url = `/api/posts${stringifiedQuery}`;

  const data = await fetcher(url);
  if (!data) return;

  const page = data.docs[0];

  return page;
};

export const fetchPostSlugs = async () => {
  const url = `/api/posts/slugs`;
  const data = await fetcher(url);

  return data;
};
