import escapeHTML from "escape-html";
import { MotionProps } from "framer-motion";
import React, { Fragment } from "react";
import { Node, Text } from "slate";

export const joinClassNames = (...classes: string[]) => {
  return classes.filter(Boolean).join(" ");
};

export const getAbsolutePath = (path: string) => {
  return `/${path}`;
};

export const paginate = (items: any[], page: number = 1, perPage: number = 6) => {
  const offset = perPage * (page - 1);
  const totalPages = Math.ceil(items.length / perPage);
  const paginatedItems = items.slice(offset, perPage * page);

  return {
    previousPage: page - 1 ? page - 1 : null,
    nextPage: totalPages > page ? page + 1 : null,
    total: items.length,
    totalPages: totalPages,
    items: paginatedItems,
  };
};

export const encodeText = (email: string) => {
  let codeEmail = "";

  if (email) {
    for (let index = 0; index < email.length; index++) {
      var charNum = "000";
      var curChar = email.charAt(index);
      if (curChar == "A") {
        charNum = "065";
      }
      if (curChar == "a") {
        charNum = "097";
      }
      if (curChar == "B") {
        charNum = "066";
      }
      if (curChar == "b") {
        charNum = "098";
      }
      if (curChar == "C") {
        charNum = "067";
      }
      if (curChar == "c") {
        charNum = "099";
      }
      if (curChar == "D") {
        charNum = "068";
      }
      if (curChar == "d") {
        charNum = "100";
      }
      if (curChar == "E") {
        charNum = "069";
      }
      if (curChar == "e") {
        charNum = "101";
      }
      if (curChar == "F") {
        charNum = "070";
      }
      if (curChar == "f") {
        charNum = "102";
      }
      if (curChar == "G") {
        charNum = "071";
      }
      if (curChar == "g") {
        charNum = "103";
      }
      if (curChar == "H") {
        charNum = "072";
      }
      if (curChar == "h") {
        charNum = "104";
      }
      if (curChar == "I") {
        charNum = "073";
      }
      if (curChar == "i") {
        charNum = "105";
      }
      if (curChar == "J") {
        charNum = "074";
      }
      if (curChar == "j") {
        charNum = "106";
      }
      if (curChar == "K") {
        charNum = "075";
      }
      if (curChar == "k") {
        charNum = "107";
      }
      if (curChar == "L") {
        charNum = "076";
      }
      if (curChar == "l") {
        charNum = "108";
      }
      if (curChar == "M") {
        charNum = "077";
      }
      if (curChar == "m") {
        charNum = "109";
      }
      if (curChar == "N") {
        charNum = "078";
      }
      if (curChar == "n") {
        charNum = "110";
      }
      if (curChar == "O") {
        charNum = "079";
      }
      if (curChar == "o") {
        charNum = "111";
      }
      if (curChar == "P") {
        charNum = "080";
      }
      if (curChar == "p") {
        charNum = "112";
      }
      if (curChar == "Q") {
        charNum = "081";
      }
      if (curChar == "q") {
        charNum = "113";
      }
      if (curChar == "R") {
        charNum = "082";
      }
      if (curChar == "r") {
        charNum = "114";
      }
      if (curChar == "S") {
        charNum = "083";
      }
      if (curChar == "s") {
        charNum = "115";
      }
      if (curChar == "T") {
        charNum = "084";
      }
      if (curChar == "t") {
        charNum = "116";
      }
      if (curChar == "U") {
        charNum = "085";
      }
      if (curChar == "u") {
        charNum = "117";
      }
      if (curChar == "V") {
        charNum = "086";
      }
      if (curChar == "v") {
        charNum = "118";
      }
      if (curChar == "W") {
        charNum = "087";
      }
      if (curChar == "w") {
        charNum = "119";
      }
      if (curChar == "X") {
        charNum = "088";
      }
      if (curChar == "x") {
        charNum = "120";
      }
      if (curChar == "Y") {
        charNum = "089";
      }
      if (curChar == "y") {
        charNum = "121";
      }
      if (curChar == "Z") {
        charNum = "090";
      }
      if (curChar == "z") {
        charNum = "122";
      }
      if (curChar == "0") {
        charNum = "048";
      }
      if (curChar == "1") {
        charNum = "049";
      }
      if (curChar == "2") {
        charNum = "050";
      }
      if (curChar == "3") {
        charNum = "051";
      }
      if (curChar == "4") {
        charNum = "052";
      }
      if (curChar == "5") {
        charNum = "053";
      }
      if (curChar == "6") {
        charNum = "054";
      }
      if (curChar == "7") {
        charNum = "055";
      }
      if (curChar == "8") {
        charNum = "056";
      }
      if (curChar == "9") {
        charNum = "057";
      }
      if (curChar == "&") {
        charNum = "038";
      }
      if (curChar == " ") {
        charNum = "032";
      }
      if (curChar == "_") {
        charNum = "095";
      }
      if (curChar == "-") {
        charNum = "045";
      }
      if (curChar == "@") {
        charNum = "064";
      }
      if (curChar == ".") {
        charNum = "046";
      }
      if (charNum == "000") {
        codeEmail += curChar;
      } else {
        codeEmail += "&#" + charNum + ";";
      }
    }
  }
  return codeEmail;
};

export const shorten = (str: string, maxLen: number, separator: string = " ") => {
  if (str.length <= maxLen) return str;
  return str.substr(0, str.lastIndexOf(separator, maxLen));
};

export const serialize = (children: Node[]) =>
  children.map((node: Node, i) => {
    if (Text.isText(node)) {
      let text = <span dangerouslySetInnerHTML={{ __html: escapeHTML(node.text) }} />;

      if (node.bold) {
        text = <strong key={i}>{text}</strong>;
      }

      if (node.code) {
        text = <code key={i}>{text}</code>;
      }

      if (node.italic) {
        text = <em key={i}>{text}</em>;
      }

      return <Fragment key={i}>{text}</Fragment>;
    }

    if (!node) {
      return null;
    }

    switch (node.type) {
      case "h1":
        return <h1 key={i}>{serialize(node.children)}</h1>;
      case "h6":
        return <h6 key={i}>{serialize(node.children)}</h6>;
      case "quote":
        return <blockquote key={i}>{serialize(node.children)}</blockquote>;
      case "ul":
        return <ul key={i}>{serialize(node.children)}</ul>;
      case "ol":
        return <ol key={i}>{serialize(node.children)}</ol>;
      case "li":
        return <li key={i}>{serialize(node.children)}</li>;
      case "link":
        return (
          <a href={escapeHTML(node.url)} key={i}>
            {serialize(node.children)}
          </a>
        );

      default:
        return <p key={i}>{serialize(node.children)}</p>;
    }
  });

export const createImageUrl = (url: string) => {
  return `${url}`;
};

export const fetcher = async (url: string) => {
  try {
    const res = await fetch(`${process.env.NEXT_PUBLIC_CMS_URL}${url}`);
    const data = await res.json();
    return data;
  } catch (error) {
    // TypeError: Failed to fetch
    console.log("There was an error", error);
  }
};

export const animateOpacity: MotionProps = {
  initial: { opacity: 0 },
  whileInView: { opacity: 1 },
  transition: { duration: 1, delay: 0.25 },
};

export const animateFromLeft: MotionProps = {
  initial: { x: 300, opacity: 0 },
  whileInView: { x: 0, opacity: 1 },
  transition: { delay: 0.5 },
};
