import { marginBottom } from "../fields/marginBottom";
import type { Block } from "payload/types";

export const EmployeeBlock: Block = {
  slug: "employeesBlock",
  labels: {
    singular: "Zaměstnanci",
    plural: "Zaměstnanci",
  },
  fields: [
    {
      name: "employees",
      label: "Zaměstnanci",
      type: "json",
      admin: {
        disabled: true,
      },
      hooks: {
        afterRead: [
          async ({ req }) => {
            const { docs } = await req.payload.find({
              collection: "employees",
              pagination: false,
            });
            return docs;
          },
        ],
      },
    },
    marginBottom(),
  ],
};
