import { marginBottom } from "../fields/marginBottom";
import type { Block } from "payload/types";

export const Faq: Block = {
  slug: "faq",
  labels: {
    singular: "Často kladené dotazy",
    plural: "Často kladené dotazy",
  },
  fields: [
    {
      name: "questions",
      labels: {
        singular: "Otázka",
        plural: "Otázky",
      },
      type: "array",
      minRows: 1,
      fields: [
        {
          name: "title",
          label: "Text otázky",
          type: "text",
          required: true,
        },
        {
          name: "content",
          label: "Odpověď otázky",
          type: "textarea",
          required: true,
        },
      ],
    },
    marginBottom(),
  ],
};
