import type { Block } from "payload/types";

export const Gallery: Block = {
  slug: "gallery",
  labels: {
    singular: "Galerie",
    plural: "Galerie",
  },
  fields: [
    {
      name: "images",
      label: "Obrázky",
      labels: {
        singular: "Obrázek",
        plural: "Obrázky",
      },
      type: "array",
      minRows: 1,
      fields: [
        {
          name: "image",
          type: "upload",
          relationTo: "media",
          required: true,
        },
      ],
    },
  ],
};
