import { marginBottom } from "../fields/marginBottom";
import { Block } from "payload/types";

export const Image: Block = {
  slug: "image",
  labels: {
    singular: "Obrázek",
    plural: "Obrázky",
  },
  fields: [
    {
      name: "image",
      label: "Obrázek",
      type: "upload",
      relationTo: "media",
      required: true,
    },
    {
      name: "width",
      label: "Šířka obrázku",
      type: "radio",
      options: [
        { label: "1/4 šířky", value: "1/4" },
        { label: "1/3 šířky", value: "1/3" },
        { label: "1/2 šířky", value: "1/2" },
        { label: "2/3 šířky", value: "2/3" },
        { label: "3/4 šířky", value: "3/4" },
        { label: "Plná šířka", value: "full" },
      ],
      defaultValue: "1/4",
      admin: {
        layout: "horizontal",
      },
    },
    {
      name: "showCaption",
      type: "checkbox",
      label: "Zobrazit titulek pod obrázkem?",
    },
    {
      name: "setPriority",
      type: "checkbox",
      label: "Nastavit prioritu načítání obrázku",
    },
    {
      name: "caption",
      type: "text",
      label: "Titulek",
      admin: {
        condition: (_, { showCaption }) => showCaption === true,
      },
    },
    marginBottom(),
  ],
};
