import type { Block } from "payload/types";

export const OwlCarousel: Block = {
  slug: "owlCarousel",
  labels: {
    singular: "Karusel",
    plural: "Karusely",
  },
  fields: [
    {
      name: "items",
      label: "Položky",
      labels: {
        singular: "Položka",
        plural: "Položky",
      },
      type: "array",
      minRows: 1,
      fields: [
        {
          name: "icon",
          label: "Ikona",
          type: "upload",
          relationTo: "media",
          maxDepth: 10,
          required: true,
        },
        {
          name: "title",
          label: "Nadpis",
          type: "text",
          required: true,
        },
        {
          name: "description",
          label: "Popisek",
          type: "text",
          required: true,
        },
      ],
    },
  ],
};
