import { marginBottom } from "../fields/marginBottom";
import richText from "../fields/richText";
import type { Block } from "payload/types";

export const Timeline: Block = {
  slug: "timeline",
  labels: {
    singular: "Časová osa",
    plural: "Časové osy",
  },
  fields: [
    {
      name: "items",
      label: "Položky",
      labels: {
        singular: "Položka",
        plural: "Položky",
      },
      type: "array",
      minRows: 1,
      fields: [
        {
          name: "title",
          label: "Nadpis",
          type: "text",
          required: true,
        },
        richText({ name: "description" }),
      ],
    },
    marginBottom(),
  ],
};
