import { marginBottom } from "../fields/marginBottom";
import { Block } from "payload/types";

export const Video: Block = {
  slug: "videoBlock",
  labels: {
    singular: "Video",
    plural: "Videa",
  },
  fields: [
    {
      name: "video",
      label: "Video",
      type: "upload",
      relationTo: "videos",
      required: true,
    },
    {
      name: "width",
      label: "Šířka videa",
      type: "radio",
      options: [
        { label: "1/4 šířky", value: "1/4" },
        { label: "1/3 šířky", value: "1/3" },
        { label: "1/2 šířky", value: "1/2" },
        { label: "2/3 šířky", value: "2/3" },
        { label: "3/4 šířky", value: "3/4" },
        { label: "Plná šířka", value: "full" },
      ],
      defaultValue: "1/4",
      admin: {
        layout: "horizontal",
      },
    },
    {
      name: "showCaption",
      type: "checkbox",
      label: "Zobrazit titulek pod videem?",
    },
    {
      name: "caption",
      type: "text",
      label: "Titulek",
      admin: {
        condition: (_, { showCaption }) => showCaption === true,
      },
    },
    marginBottom(),
  ],
};
