import { regeneratePage } from "../utilities/regeneratePage";
import path from "path";
import { CollectionConfig } from "payload/types";

const Documents: CollectionConfig = {
  slug: "documents",
  labels: {
    singular: "Dokument",
    plural: "Dokumenty",
  },
  admin: {
    useAsTitle: "title",
  },
  hooks: {
    afterDelete: [
      ({ req: { payload } }) => {
        regeneratePage({
          payload,
        });
      },
    ],
    afterChange: [
      ({ req: { payload } }) => {
        regeneratePage({
          payload,
        });
      },
    ],
  },
  access: {
    read: () => {
      return true;
    },
    create: () => {
      return true;
    },
  },
  upload: {
    staticURL: "/documents",
    staticDir: path.resolve(__dirname, "../../documents"),
    mimeTypes: [
      "application/pdf",
      "application/zip",
      "application/x-zip-compressed",
    ],
  },
  fields: [
    {
      name: "title",
      label: "Název",
      localized: true,
      type: "text",
      required: true,
    },
  ],
};

export default Documents;
