import { CollectionConfig } from "payload/types";

const Users: CollectionConfig = {
  slug: "users",
  auth: true,
  admin: {
    useAsTitle: "email",
  },
  labels: {
    singular: "Uživatel",
    plural: "Uživatelé",
  },
  access: {
    read: () => {
      return true;
    },
  },
  fields: [
    {
      name: "name",
      label: "Jméno",
      type: "text",
      required: true,
    },
    {
      name: "image",
      label: "Profilový obrázek",
      type: "upload",
      relationTo: "media",
      admin: {
        condition: () => {
          if (typeof window !== "undefined") {
            const path = window.location.pathname;
            if (path === "/admin/create-first-user") {
              return false;
            }
            return true;
          }
        },
      },
    },
  ],
};

export default Users;
