import Cell from "./Cell";
import InputField from "./InputField";
import { Field } from "payload/types";

export const validateHexColor = (value: string = ""): true | string => {
  if (value != "") {
    return (
      value.match(/^#(?:[0-9a-fA-F]{3}){1,2}$/) !== null ||
      `Prosím uveď validní hex kód barvy`
    );
  }
};

const colorField: Field = {
  name: "color",
  label: "Barva",
  type: "text",
  validate: validateHexColor,
  admin: {
    components: {
      Field: InputField,
      Cell,
    },
  },
};

export default colorField;
