import deepMerge from "../utilities/deepMerge";
import type { Field } from "payload/types";

type Slug = (fieldToUse?: string, overrides?: Partial<Field>) => Field;

export const marginTop: Slug = (fieldToUse = "title", overrides = {}) =>
  deepMerge<Field, Partial<Field>>(
    {
      name: "marginTop",
      label: "Vnější odsazení nad objektem",
      type: "radio",
      options: [
        { label: "Žádné", value: "none" },
        { label: "Velmi malé", value: "xs" },
        { label: "Malé", value: "sm" },
        { label: "Střední", value: "md" },
        { label: "Velké", value: "lg" },
      ],
      defaultValue: "none",
      admin: {
        layout: "horizontal",
        description:
          "Vnější odsazení nad objektem slouží k odsazení bloku od zbylého obsahu na stránce.",
      },
    },
    overrides
  );
