import deepMerge from "../utilities/deepMerge";
import type { Field } from "payload/types";

type Slug = (fieldToUse?: string, overrides?: Partial<Field>) => Field;

export const textAlign: Slug = (fieldToUse = "title", overrides = {}) =>
  deepMerge<Field, Partial<Field>>(
    {
      name: "textAlign",
      label: "Zarovnání textu",
      type: "radio",
      options: [
        { label: "Nalevo", value: "left" },
        { label: "Na střed", value: "center" },
        { label: "Napravo", value: "right" },
        { label: "Do bloku", value: "justify" },
      ],
      defaultValue: "left",
      admin: {
        layout: "horizontal",
        description: "Slouží k zarovnání pouze textu, nikoliv jiného obsahu.",
      },
    },
    overrides
  );
