import { regeneratePage } from "../utilities/regeneratePage";
import { GlobalConfig } from "payload/types";

const Cookies: GlobalConfig = {
  slug: "cookies",
  label: "Nastavení cookies",
  access: {
    read: () => {
      return true;
    },
  },
  hooks: {
    afterChange: [
      ({ req: { payload } }) => {
        regeneratePage({
          payload,
        });
      },
    ],
  },
  fields: [
    {
      name: "agreement",
      label: "Základní ustanovení ke cookies",
      type: "richText",
    },
    {
      name: "categories",
      label: "Sbírané kategorie cookies",
      labels: {
        singular: "Kategorie",
        plural: "Kategorie",
      },
      type: "array",
      fields: [
        {
          name: "title",
          label: "Název kategorie",
          type: "text",
        },
        {
          name: "description",
          label: "Popis kategorie",
          type: "richText",
        },
      ],
    },
    {
      name: "additionalInformation",
      label: "Dodatečné informace ke cookies",
      type: "richText",
    },
  ],
};

export default Cookies;
