import { regeneratePage } from "../utilities/regeneratePage";
import { GlobalConfig } from "payload/types";

const SocialSites: GlobalConfig = {
  slug: "socialSites",
  label: "Sociální sítě",
  access: {
    read: () => {
      return true;
    },
  },
  hooks: {
    afterChange: [
      ({ req: { payload } }) => {
        regeneratePage({
          payload,
        });
      },
    ],
  },
  fields: [
    {
      name: "showInstagram",
      label: "Zobrazovat Instagram odkaz",
      type: "checkbox",
      defaultValue: false,
    },
    {
      name: "instagramUrl",
      label: "Instagram",
      type: "text",
      required: true,
      admin: {
        condition: (data, siblingData) => {
          if (data.showInstagram) {
            return true;
          } else {
            return false;
          }
        },
      },
    },
    {
      name: "showFacebook",
      label: "Zobrazovat Facebook odkaz",
      type: "checkbox",
      defaultValue: false,
    },
    {
      name: "facebookUrl",
      label: "Facebook",
      type: "text",
      required: true,
      admin: {
        condition: (data, siblingData) => {
          if (data.showFacebook) {
            return true;
          } else {
            return false;
          }
        },
      },
    },
    {
      name: "showLinkedIn",
      label: "Zobrazovat LinkedIn odkaz",
      type: "checkbox",
      defaultValue: false,
    },
    {
      name: "linkedInUrl",
      label: "LinkedIn",
      type: "text",
      required: true,
      admin: {
        condition: (data, siblingData) => {
          if (data.showLinkedIn) {
            return true;
          } else {
            return false;
          }
        },
      },
    },
    {
      name: "showTwitter",
      label: "Zobrazovat Twitter odkaz",
      type: "checkbox",
      defaultValue: false,
    },
    {
      name: "twitterUrl",
      label: "Twitter",
      type: "text",
      required: true,
      admin: {
        condition: (data, siblingData) => {
          if (data.showTwitter) {
            return true;
          } else {
            return false;
          }
        },
      },
    },
  ],
};

export default SocialSites;
